---
vim: spell spelllang=cs
---

# GIT chectsheet

## Vytvoření repozitáře

-   přes github/gitlab + `git clone URL`
*   ručně:
    *   `git init`
    *   `git commit` -- vytvoření commitu
    *   a zveřejnění:
    *   `git remote add origin URL` -- přidání URL k publikaci
    *   `git push --set-upstream origin master` -- první push

## Základní operace

*   `git pull [--rebase]`
*   `git add FILE` / `git add --patch`
*   `git commit [--patch]`
*   `git push`
*   `git status`
*   `git log`

## Jak na konflikty

*   sleduj, co `git` chce, správa o konfliktu obsahuje i návod jak ho vyřešit
*   sleduj `git status`
*   lokální změny v souboru lze odstranit pomocí `git checkout FILE`

## Tutoriál 1: základy + `pull` konflikt

#.  nový repozitář na gitlabu
#.  clone repozitáře k sobě
#.  vytvořte soubor
#.  přidejte jen pomocí `git add`
#.  vytvořte commit a pošlete ho na server
#.  přidejte člověku sedícímu vedle vás právo zapisovat do vašeho repozitáře a
počkejte až vám dá přístup do svého (práva se přidělují přes gitlab)
#.  stáhněte si repozitář vašeho souseda
#.  změňte jeho soubor a proveďte `commit` + `push` těchto změn
#.  jděte do svého repozitáře, nestahujte změny, změňte svůj soubor, proveďte
`commit` změn
#.  udělejte `pull` git vám oznámí konflikt
#.  odstraňte konflikt editací souboru dle libosti
#.  pomocí `git add` přidejte změny v souboru
#.  spusťte `git commit`: vytvoří se merge commit
#.  podívejte se na log, zveřejněte merge commit

## Tutoriál 2: `pull --rebase` konflikt

#.  stáhněte si aktuální verzi sousedova repozitáře
#.  opět změňte jeho soubor a změny zveřejněte
#.  jděte do svého repozitáře, změňte svůj soubor a udělejte commit
#.  spusťte `git pull --rebase`
#.  editujte konflikt, spusťte `git add FILE`
#.  `git rebase --continue`
#.  podívejte se na log, zveřejněte

## Tutoriál 3: 

